module("luci.controller.admin.network",package.seeall)
function index()
local t=require("luci.model.uci").cursor()
local e
e=node("admin","network")
e.target=firstchild()
e.title=_("Network")
e.order=50
e.index=true
local a=false
t:foreach("network","switch",
function(e)
a=true
return false
end)
if a then
e=node("admin","network","vlan")
e.target=cbi("admin_network/vlan")
e.title=_("Switch")
e.order=20
e=entry({"admin","network","switch_status"},call("switch_status"),nil)
e.leaf=true
end
local a=false
t:foreach("wireless","wifi-device",
function(e)
a=true
return false
end)
if a then
e=entry({"admin","network","wireless_assoclist"},call("wifi_assoclist"),nil)
e.leaf=true
e=entry({"admin","network","wireless_join"},post("wifi_join"),nil)
e.leaf=true
e=entry({"admin","network","wireless_add"},post("wifi_add"),nil)
e.leaf=true
e=entry({"admin","network","wireless_status"},call("wifi_status"),nil)
e.leaf=true
e=entry({"admin","network","wireless_reconnect"},post("wifi_reconnect"),nil)
e.leaf=true
e=entry({"admin","network","wireless_scan_trigger"},post("wifi_scan_trigger"),nil)
e.leaf=true
e=entry({"admin","network","wireless_scan_results"},call("wifi_scan_results"),nil)
e.leaf=true
e=entry({"admin","network","wireless"},arcombine(cbi("admin_network/wifi_overview"),cbi("admin_network/wifi")),_("Wireless"),15)
e.leaf=true
e.subindex=true
if e.inreq then
local e
local e=require"luci.model.network".init(t)
for e,t in ipairs(e:get_wifidevs())do
local e
for a,e in ipairs(t:get_wifinets())do
entry(
{"admin","network","wireless",e:id()},
alias("admin","network","wireless"),
t:name()..": "..e:shortname()
)
end
end
end
end
e=entry({"admin","network","iface_add"},form("admin_network/iface_add"),nil)
e.leaf=true
e=entry({"admin","network","iface_status"},call("iface_status"),nil)
e.leaf=true
e=entry({"admin","network","iface_reconnect"},post("iface_reconnect"),nil)
e.leaf=true
e=entry({"admin","network","network"},arcombine(cbi("admin_network/network"),cbi("admin_network/ifaces")),_("Interfaces"),10)
e.leaf=true
e.subindex=true
if e.inreq then
t:foreach("network","interface",
function(e)
local e=e[".name"]
if e~="loopback"then
entry({"admin","network","network",e},
true,e:upper())
end
end)
end
if nixio.fs.access("/etc/config/dhcp")then
e=node("admin","network","dhcp")
e.target=cbi("admin_network/dhcp")
e.title=_("DHCP and DNS")
e.order=30
e=entry({"admin","network","dhcplease_status"},call("lease_status"),nil)
e.leaf=true
e=node("admin","network","hosts")
e.target=cbi("admin_network/hosts")
e.title=_("Hostnames")
e.order=40
end
e=node("admin","network","routes")
e.target=cbi("admin_network/routes")
e.title=_("Static Routes")
e.order=50
e=node("admin","network","diagnostics")
e.target=template("admin_network/diagnostics")
e.title=_("Diagnostics")
e.order=60
e=entry({"admin","network","diag_ping"},post("diag_ping"),nil)
e.leaf=true
e=entry({"admin","network","diag_nslookup"},post("diag_nslookup"),nil)
e.leaf=true
e=entry({"admin","network","diag_traceroute"},post("diag_traceroute"),nil)
e.leaf=true
e=entry({"admin","network","diag_ping6"},post("diag_ping6"),nil)
e.leaf=true
e=entry({"admin","network","diag_traceroute6"},post("diag_traceroute6"),nil)
e.leaf=true
end
function wifi_join()
local t=require"luci.template"
local e=require"luci.http"
local o=e.formvalue("device")
local a=e.formvalue("join")
if o and a then
local e=(e.formvalue("cancel")or e.formvalue("cbi.cancel"))
if not e then
local a=require"luci.cbi"
local e=luci.cbi.load("admin_network/wifi_add")[1]
if e:parse()~=a.FORM_DONE then
t.render("header")
e:render()
t.render("footer")
end
return
end
end
t.render("admin_network/wifi_join")
end
function wifi_add()
local e=luci.http.formvalue("device")
local t=require"luci.model.network".init()
e=e and t:get_wifidev(e)
if e then
local e=e:add_wifinet({
mode="ap",
ssid="OpenWrt",
encryption="none"
})
t:save("wireless")
luci.http.redirect(e:adminlink())
end
end
function iface_status(e)
local t=require"luci.model.network".init()
local a={}
local o
for o in e:gmatch("[%w%.%-_]+")do
local e=t:get_network(o)
local t=e and e:get_interface()
if t then
local t={
id=o,
desc=e:get_i18n(),
proto=e:proto(),
uptime=e:uptime(),
gwaddr=e:gwaddr(),
ipaddrs=e:ipaddrs(),
ip6addrs=e:ip6addrs(),
dnsaddrs=e:dnsaddrs(),
ip6prefix=e:ip6prefix(),
errors=e:errors(),
name=t:shortname(),
type=t:type(),
typename=t:get_type_i18n(),
ifname=t:name(),
macaddr=t:mac(),
is_up=e:is_up()and t:is_up(),
is_alias=e:is_alias(),
is_dynamic=e:is_dynamic(),
rx_bytes=t:rx_bytes(),
tx_bytes=t:tx_bytes(),
rx_packets=t:rx_packets(),
tx_packets=t:tx_packets(),
subdevices={}
}
for o,e in ipairs(e:get_interfaces()or{})do
t.subdevices[#t.subdevices+1]={
name=e:shortname(),
type=e:type(),
typename=e:get_type_i18n(),
ifname=e:name(),
macaddr=e:mac(),
is_up=e:is_up(),
rx_bytes=e:rx_bytes(),
tx_bytes=e:tx_bytes(),
rx_packets=e:rx_packets(),
tx_packets=e:tx_packets(),
}
end
a[#a+1]=t
else
a[#a+1]={
id=o,
name=o,
type="ethernet"
}
end
end
if#a>0 then
luci.http.prepare_content("application/json")
luci.http.write_json(a)
return
end
luci.http.status(404,"No such device")
end
function iface_reconnect(e)
local t=require"luci.model.network".init()
local t=t:get_network(e)
if t then
luci.sys.call("env -i /sbin/ifup %s >/dev/null 2>/dev/null"
%luci.util.shellquote(e))
luci.http.status(200,"Reconnected")
return
end
luci.http.status(404,"No such interface")
end
function wifi_status(t)
local a=require"luci.tools.status"
local e={}
if type(t)=="string"then
local o
for t in t:gmatch("[%w%.%-]+")do
e[#e+1]=a.wifi_network(t)
end
end
if#e>0 then
luci.http.prepare_content("application/json")
luci.http.write_json(e)
return
end
luci.http.status(404,"No such device")
end
function wifi_reconnect(e)
local e=luci.sys.call("env -i /sbin/wifi up %s"%luci.util.shellquote(e))
if e==0 then
luci.http.status(200,"Reconnected")
else
luci.http.status(500,"Error")
end
end
function wifi_assoclist()
local e=require"luci.tools.status"
luci.http.prepare_content("application/json")
luci.http.write_json(e.wifi_assoclist())
end
local function i(t)
local e=luci.util.ubus("session","get",{
ubus_rpc_session=luci.model.uci:get_session_id(),
keys={t}
})
if type(e)=="table"and
type(e.values)=="table"and
type(e.values[t])=="table"
then
return e.values[t]
end
return{}
end
function wifi_scan_trigger(t,n)
local o=t and luci.sys.wifi.getiwinfo(t)
if not o then
luci.http.status(404,"No such radio device")
return
end
luci.http.status(200,"Scan scheduled")
if nixio.fork()==0 then
io.stderr:close()
io.stdout:close()
local e,e
local e,a={},{}
local t="scan_%s"%t
luci.util.ubus("session","set",{
ubus_rpc_session=luci.model.uci:get_session_id(),
values={[t]=nil}
})
for o,t in ipairs(o.scanlist or{})do
e[o]=t
a[t.bssid]=t
end
if n then
for o,t in ipairs(i(t))do
if not a[t.bssid]then
t.stale=true
e[#e+1]=t
end
end
end
luci.util.ubus("session","set",{
ubus_rpc_session=luci.model.uci:get_session_id(),
values={[t]=e}
})
end
end
function wifi_scan_results(e)
local e=e and i("scan_%s"%e)
if e and#e>0 then
luci.http.prepare_content("application/json")
luci.http.write_json(e)
else
luci.http.status(404,"No wireless scan results")
end
end
function lease_status()
local e=require"luci.tools.status"
luci.http.prepare_content("application/json")
luci.http.write('[')
luci.http.write_json(e.dhcp_leases())
luci.http.write(',')
luci.http.write_json(e.dhcp6_leases())
luci.http.write(']')
end
function switch_status(e)
local t=require"luci.tools.status"
luci.http.prepare_content("application/json")
luci.http.write_json(t.switch_status(e))
end
function diag_command(t,e)
if e and e:match("^[a-zA-Z0-9%-%.:_]+$")then
luci.http.prepare_content("text/plain")
local e=io.popen(t%luci.util.shellquote(e))
if e then
while true do
local e=e:read("*l")
if not e then break end
luci.http.write(e)
luci.http.write("\n")
end
e:close()
end
return
end
luci.http.status(500,"Bad address")
end
function diag_ping(e)
diag_command("ping -c 5 -W 1 %s 2>&1",e)
end
function diag_traceroute(e)
diag_command("traceroute -q 1 -w 1 -n %s 2>&1",e)
end
function diag_nslookup(e)
diag_command("nslookup %s 2>&1",e)
end
function diag_ping6(e)
diag_command("ping6 -c 5 %s 2>&1",e)
end
function diag_traceroute6(e)
diag_command("traceroute6 -q 1 -w 2 -n %s 2>&1",e)
end
