module("luci.controller.admin.system",package.seeall)
function index()
local e=require"nixio.fs"
entry({"admin","system"},alias("admin","system","system"),_("System"),30).index=true
entry({"admin","system","system"},cbi("admin_system/system"),_("System"),1)
entry({"admin","system","clock_status"},post_on({set=true},"action_clock_status"))
entry({"admin","system","admin"},cbi("admin_system/admin"),_("Administration"),2)
if e.access("/bin/opkg")then
entry({"admin","system","packages"},post_on({exec="1"},"action_packages"),_("Software"),10)
entry({"admin","system","packages","ipkg"},form("admin_system/ipkg"))
end
entry({"admin","system","startup"},form("admin_system/startup"),_("Startup"),45)
entry({"admin","system","crontab"},form("admin_system/crontab"),_("Scheduled Tasks"),46)
if e.access("/sbin/block")and e.access("/etc/config/fstab")then
entry({"admin","system","fstab"},cbi("admin_system/fstab"),_("Mount Points"),50)
entry({"admin","system","fstab","mount"},cbi("admin_system/fstab/mount"),nil).leaf=true
entry({"admin","system","fstab","swap"},cbi("admin_system/fstab/swap"),nil).leaf=true
end
local t,e=e.glob("/sys/class/leds/*")
if e>0 then
entry({"admin","system","leds"},cbi("admin_system/leds"),_("<abbr title=\"Light Emitting Diode\">LED</abbr> Configuration"),60)
end
entry({"admin","system","flashops"},call("action_flashops"),_("Backup / Flash Firmware"),70)
entry({"admin","system","flashops","reset"},post("action_reset"))
entry({"admin","system","flashops","backup"},post("action_backup"))
entry({"admin","system","flashops","backupfiles"},form("admin_system/backupfiles"))
entry({"admin","system","flashops","restore"},call("action_restore"))
entry({"admin","system","flashops","sysupgrade"},call("action_sysupgrade"))
entry({"admin","system","reboot"},template("admin_system/reboot"),_("Reboot"),90)
entry({"admin","system","reboot","call"},post("action_reboot"))
end
function action_clock_status()
local e=tonumber(luci.http.formvalue("set"))
if e~=nil and e>0 then
local e=os.date("*t",e)
if e then
luci.sys.call("date -s '%04d-%02d-%02d %02d:%02d:%02d'"%{
e.year,e.month,e.day,e.hour,e.min,e.sec
})
luci.sys.call("/etc/init.d/sysfixtime restart")
end
end
luci.http.prepare_content("application/json")
luci.http.write_json({timestring=os.date("%c")})
end
function action_packages()
local d=require"nixio.fs"
local n=require"luci.model.ipkg"
local m=(luci.http.formvalue("exec")=="1")
local l,h
local r=false
local u={}
local c={}
local e={""}
local t={""}
local o,a
local f=luci.http.formvalue("display")or"available"
local i=string.byte(luci.http.formvalue("letter")or"A",1)
i=(i==35 or(i>=65 and i<=90))and i or 65
local s=luci.http.formvalue("query")
s=(s~='')and s or nil
if m then
local s=luci.http.formvalue("install")
local i=nil
local d=luci.http.formvalue("url")
if d and d~=''then
i=d
end
if s then
u[s],o,a=n.install(s)
e[#e+1]=o
t[#t+1]=a
r=true
end
if i then
local s
for s in luci.util.imatch(i)do
u[i],o,a=n.install(s)
e[#e+1]=o
t[#t+1]=a
r=true
end
end
local i=luci.http.formvalue("remove")
if i then
c[i],o,a=n.remove(i)
e[#e+1]=o
t[#t+1]=a
r=true
end
l=luci.http.formvalue("update")
if l then
l,o,a=n.update()
e[#e+1]=o
t[#t+1]=a
end
h=luci.http.formvalue("upgrade")
if h then
h,o,a=n.upgrade()
e[#e+1]=o
t[#t+1]=a
end
end
local o=true
local a=false
if d.access("/var/opkg-lists/")then
local e
for e in d.dir("/var/opkg-lists/")do
o=false
if(d.stat("/var/opkg-lists/"..e,"mtime")or 0)<(os.time()-(24*60*60))then
a=true
break
end
end
end
luci.template.render("admin_system/packages",{
display=f,
letter=i,
query=s,
install=u,
remove=c,
update=l,
upgrade=h,
no_lists=o,
old_lists=a,
stdout=table.concat(e,""),
stderr=table.concat(t,"")
})
if r then
d.unlink("/tmp/luci-indexcache")
end
end
local function s(e)
return(os.execute("sysupgrade -T %q >/dev/null"%e)==0)
end
local function h(e)
return(luci.sys.exec("md5sum %q"%e):match("^([^%s]+)"))
end
local function r(e)
return(luci.sys.exec("sha256sum %q"%e):match("^([^%s]+)"))
end
local function n()
return nixio.fs.access("/lib/upgrade/platform.sh")
end
local function o()
return(os.execute([[grep -sq "^overlayfs:/overlay / overlay " /proc/mounts]])==0)
end
local function d()
local e=0
if nixio.fs.access("/proc/mtd")then
for t in io.lines("/proc/mtd")do
local o,a,o,t=t:match('^([^%s]+)%s+([^%s]+)%s+([^%s]+)%s+"([^%s]+)"')
if t=="linux"or t=="firmware"then
e=tonumber(a,16)
break
end
end
elseif nixio.fs.access("/proc/partitions")then
for t in io.lines("/proc/partitions")do
local o,o,t,a=t:match('^%s*(%d+)%s+(%d+)%s+([^%s]+)%s+([^%s]+)')
if t and a and not a:match('[0-9]')then
e=tonumber(t)*1024
break
end
end
end
return e
end
function action_flashops()
luci.template.render("admin_system/flashops",{
reset_avail=o(),
upgrade_avail=n()
})
end
function action_sysupgrade()
local i=require"nixio.fs"
local a=require"luci.http"
local e="/tmp/firmware.img"
local t
a.setfilehandler(
function(a,o,i)
if not t and a and a.name=="image"then
t=io.open(e,"w")
end
if t and o then
t:write(o)
end
if t and i then
t:close()
end
end
)
if not luci.dispatcher.test_post_security()then
i.unlink(e)
return
end
if a.formvalue("cancel")then
i.unlink(e)
a.redirect(luci.dispatcher.build_url('admin/system/flashops'))
return
end
local t=tonumber(a.formvalue("step")or 1)
if t==1 then
if s(e)then
luci.template.render("admin_system/upgrade",{
checksum=h(e),
sha256ch=r(e),
storage=d(),
size=(i.stat(e,"size")or 0),
keep=(not not a.formvalue("keep"))
})
else
i.unlink(e)
luci.template.render("admin_system/flashops",{
reset_avail=o(),
upgrade_avail=n(),
image_invalid=true
})
end
elseif t==2 then
local t=(a.formvalue("keep")=="1")and""or"-n"
luci.template.render("admin_system/applyreboot",{
title=luci.i18n.translate("Flashing..."),
msg=luci.i18n.translate("The system is flashing now.<br /> DO NOT POWER OFF THE DEVICE!<br /> Wait a few minutes before you try to reconnect. It might be necessary to renew the address of your computer to reach the device again, depending on your settings."),
addr=(#t>0)and"192.168.1.1"or nil
})
fork_exec("sleep 1; killall dropbear uhttpd; sleep 1; /sbin/sysupgrade %s %q"%{t,e})
end
end
function action_backup()
local e=ltn12_popen("sysupgrade --create-backup - 2>/dev/null")
luci.http.header(
'Content-Disposition','attachment; filename="backup-%s-%s.tar.gz"'%{
luci.sys.hostname(),
os.date("%Y-%m-%d")
})
luci.http.prepare_content("application/x-targz")
luci.ltn12.pump.all(e,luci.http.write)
end
function action_restore()
local s=require"nixio.fs"
local a=require"luci.http"
local t="/tmp/restore.tar.gz"
local e
a.setfilehandler(
function(o,a,i)
if not e and o and o.name=="archive"then
e=io.open(t,"w")
end
if e and a then
e:write(a)
end
if e and i then
e:close()
end
end
)
if not luci.dispatcher.test_post_security()then
s.unlink(t)
return
end
local e=a.formvalue("archive")
if e and#e>0 then
if os.execute("gunzip -t %q >/dev/null 2>&1"%t)==0 then
luci.template.render("admin_system/applyreboot")
os.execute("tar -C / -xzf %q >/dev/null 2>&1"%t)
luci.sys.reboot()
else
luci.template.render("admin_system/flashops",{
reset_avail=o(),
upgrade_avail=n(),
backup_invalid=true
})
end
return
end
a.redirect(luci.dispatcher.build_url('admin/system/flashops'))
end
function action_reset()
if o()then
luci.template.render("admin_system/applyreboot",{
title=luci.i18n.translate("Erasing..."),
msg=luci.i18n.translate("The system is erasing the configuration partition now and will reboot itself when finished."),
addr="192.168.1.1"
})
fork_exec("sleep 1; killall dropbear uhttpd; sleep 1; jffs2reset -y && reboot")
return
end
http.redirect(luci.dispatcher.build_url('admin/system/flashops'))
end
function action_passwd()
local e=luci.http.formvalue("pwd1")
local a=luci.http.formvalue("pwd2")
local t=nil
if e or a then
if e==a then
t=luci.sys.user.setpasswd("root",e)
else
t=10
end
end
luci.template.render("admin_system/passwd",{stat=t})
end
function action_reboot()
luci.sys.reboot()
end
function fork_exec(t)
local e=nixio.fork()
if e>0 then
return
elseif e==0 then
nixio.chdir("/")
local e=nixio.open("/dev/null","w+")
if e then
nixio.dup(e,nixio.stderr)
nixio.dup(e,nixio.stdout)
nixio.dup(e,nixio.stdin)
if e:fileno()>2 then
e:close()
end
end
nixio.exec("/bin/sh","-c",t)
end
end
function ltn12_popen(i)
local a,e=nixio.pipe()
local t=nixio.fork()
if t>0 then
e:close()
local o
return function()
local e=a:read(2048)
local i,t=nixio.waitpid(t,"nohang")
if not o and i and t=="exited"then
o=true
end
if e and#e>0 then
return e
elseif o then
a:close()
return nil
end
end
elseif t==0 then
nixio.dup(e,nixio.stdout)
a:close()
e:close()
nixio.exec("/bin/sh","-c",i)
end
end
