local i=require"nixio.fs"
local e=require"luci.template"
local n=require"luci.model.network".init()
local t=require"luci.model.firewall".init()
local r=require"luci.jsonc"
m=Map("network",translate("Interfaces"))
m:chain("wireless")
m:chain("firewall")
m:chain("dhcp")
m.pageaction=false
local d=e.Template(nil,[[
	<div class="cbi-section-node">
		<div class="table">
			<%
				for i, net in ipairs(netlist) do
					local z = net[3]
					local c = z and z:get_color() or "#EEEEEE"
					local t = z and translate("Part of zone %q" % z:name()) or translate("No zone assigned")
					local disabled = (net[4]:get("auto") == "0")
					local dynamic = net[4]:is_dynamic()
			%>
				<div class="tr cbi-rowstyle-<%=i % 2 + 1%>">
					<div class="td col-3 center middle">
						<div class="ifacebox">
							<div class="ifacebox-head" style="background-color:<%=c%>" title="<%=pcdata(t)%>">
								<strong><%=net[1]:upper()%></strong>
							</div>
							<div class="ifacebox-body" id="<%=net[1]%>-ifc-devices" data-network="<%=net[1]%>">
								<img src="<%=resource%>/icons/ethernet_disabled.png" style="width:16px; height:16px" /><br />
								<small>?</small>
							</div>
						</div>
					</div>
					<div class="td col-5 left middle" id="<%=net[1]%>-ifc-description">
						<em><%:Collecting data...%></em>
					</div>
					<div class="td cbi-section-actions">
						<div>
							<input type="button" class="cbi-button cbi-button-neutral" onclick="iface_reconnect('<%=net[1]%>')" title="<%:Reconnect this interface%>" value="<%:Restart%>"<%=ifattr(disabled or dynamic, "disabled", "disabled")%> />

							<% if disabled then %>
								<input type="hidden" name="cbid.network.<%=net[1]%>.__disable__" value="1" />
								<input type="submit" name="cbi.apply" class="cbi-button cbi-button-neutral" onclick="this.previousElementSibling.value='0'" title="<%:Reconnect this interface%>" value="<%:Connect%>"<%=ifattr(dynamic, "disabled", "disabled")%> />
							<% else %>
								<input type="hidden" name="cbid.network.<%=net[1]%>.__disable__" value="0" />
								<input type="submit" name="cbi.apply" class="cbi-button cbi-button-neutral" onclick="this.previousElementSibling.value='1'" title="<%:Shutdown this interface%>" value="<%:Stop%>"<%=ifattr(dynamic, "disabled", "disabled")%> />
							<% end %>

							<input type="button" class="cbi-button cbi-button-action important" onclick="location.href='<%=url("admin/network/network", net[1])%>'" title="<%:Edit this interface%>" value="<%:Edit%>" id="<%=net[1]%>-ifc-edit"<%=ifattr(dynamic, "disabled", "disabled")%> />

							<input type="hidden" name="cbid.network.<%=net[1]%>.__delete__" value="" />
							<input type="submit" name="cbi.apply" class="cbi-button cbi-button-negative" onclick="iface_delete(event)" value="<%:Delete%>"<%=ifattr(dynamic, "disabled", "disabled")%> />
						</div>
					</div>
				</div>
			<% end %>
		</div>
	</div>
	<div class="cbi-section-create">
		<input type="button" class="cbi-button cbi-button-add" value="<%:Add new interface...%>" onclick="location.href='<%=url("admin/network/iface_add")%>'" />
	</div>
]])
local e,e
local h,a={},{}
for o,e in ipairs(n:get_networks())do
if e:name()~="loopback"then
local o=e:zonename()
local t=o and t:get_zone(o)or t:get_zone_by_network(e:name())
local o=1
if e:is_alias()then
o=2
elseif e:is_dynamic()then
o=3
end
h[#h+1]=e:name()
a[#a+1]={
e:name(),t and t:name()or"-",t,e,o
}
end
end
table.sort(a,
function(t,e)
if t[2]~=e[2]then
return t[2]<e[2]
elseif t[5]~=e[5]then
return t[5]<e[5]
else
return t[1]<e[1]
end
end)
s=m:section(TypedSection,"interface",translate("Interface Overview"))
function s.sections(e)
local t,t,e=nil,nil,{}
for a,t in ipairs(a)do
e[#e+1]=t[1]
end
return e
end
function s.render(e)
d:render({
netlist=a
})
end
o=s:option(Value,"__disable__")
function o.cfgvalue(t,e)
return(m:get(e,"auto")=="0")and"1"or"0"
end
function o.write(a,e,t)
if t~="1"then
m:set(e,"auto","")
else
m:set(e,"auto","0")
end
end
o.remove=o.write
o=s:option(Value,"__delete__")
function o.write(t,e,t)
n:del_network(e)
end
m:section(SimpleSection).template="admin_network/iface_overview_status"
if i.access("/etc/init.d/dsl_control")then
local t,e=pcall(r.parse,i.readfile("/etc/board.json"))
local e=(t==true)
and(type(e)=="table")
and(type(e.dsl)=="table")
and(type(e.dsl.modem)=="table")
and e.dsl.modem.type
dsl=m:section(TypedSection,"dsl",translate("DSL"))
dsl.anonymous=true
annex=dsl:option(ListValue,"annex",translate("Annex"))
annex:value("a",translate("Annex A + L + M (all)"))
annex:value("b",translate("Annex B (all)"))
annex:value("j",translate("Annex J (all)"))
annex:value("m",translate("Annex M (all)"))
annex:value("bdmt",translate("Annex B G.992.1"))
annex:value("b2",translate("Annex B G.992.3"))
annex:value("b2p",translate("Annex B G.992.5"))
annex:value("at1",translate("ANSI T1.413"))
annex:value("admt",translate("Annex A G.992.1"))
annex:value("alite",translate("Annex A G.992.2"))
annex:value("a2",translate("Annex A G.992.3"))
annex:value("a2p",translate("Annex A G.992.5"))
annex:value("l",translate("Annex L G.992.3 POTS 1"))
annex:value("m2",translate("Annex M G.992.3"))
annex:value("m2p",translate("Annex M G.992.5"))
tone=dsl:option(ListValue,"tone",translate("Tone"))
tone:value("",translate("auto"))
tone:value("a",translate("A43C + J43 + A43"))
tone:value("av",translate("A43C + J43 + A43 + V43"))
tone:value("b",translate("B43 + B43C"))
tone:value("bv",translate("B43 + B43C + V43"))
if e=="vdsl"then
xfer_mode=dsl:option(ListValue,"xfer_mode",translate("Encapsulation mode"))
xfer_mode:value("",translate("auto"))
xfer_mode:value("atm",translate("ATM (Asynchronous Transfer Mode)"))
xfer_mode:value("ptm",translate("PTM/EFM (Packet Transfer Mode)"))
line_mode=dsl:option(ListValue,"line_mode",translate("DSL line mode"))
line_mode:value("",translate("auto"))
line_mode:value("adsl",translate("ADSL"))
line_mode:value("vdsl",translate("VDSL"))
ds_snr=dsl:option(ListValue,"ds_snr_offset",translate("Downstream SNR offset"))
ds_snr.default="0"
for e=-100,100,5 do
ds_snr:value(e,translatef("%.1f dB",e/10))
end
end
firmware=dsl:option(Value,"firmware",translate("Firmware File"))
m.pageaction=true
end
if i.access("/usr/sbin/br2684ctl")then
atm=m:section(TypedSection,"atm-bridge",translate("ATM Bridges"),
translate("ATM bridges expose encapsulated ethernet in AAL5 "..
"connections as virtual Linux network interfaces which can "..
"be used in conjunction with DHCP or PPP to dial into the "..
"provider network."))
atm.addremove=true
atm.anonymous=true
atm.create=function(t,e)
local e=TypedSection.create(t,e)
local t=-1
m.uci:foreach("network","atm-bridge",
function(e)
local e=tonumber(e.unit)
if e~=nil and e>t then
t=e
end
end)
m.uci:set("network",e,"unit",t+1)
m.uci:set("network",e,"atmdev",0)
m.uci:set("network",e,"encaps","llc")
m.uci:set("network",e,"payload","bridged")
m.uci:set("network",e,"vci",35)
m.uci:set("network",e,"vpi",8)
return e
end
atm:tab("general",translate("General Setup"))
atm:tab("advanced",translate("Advanced Settings"))
vci=atm:taboption("general",Value,"vci",translate("ATM Virtual Channel Identifier (VCI)"))
vpi=atm:taboption("general",Value,"vpi",translate("ATM Virtual Path Identifier (VPI)"))
encaps=atm:taboption("general",ListValue,"encaps",translate("Encapsulation mode"))
encaps:value("llc",translate("LLC"))
encaps:value("vc",translate("VC-Mux"))
atmdev=atm:taboption("advanced",Value,"atmdev",translate("ATM device number"))
unit=atm:taboption("advanced",Value,"unit",translate("Bridge unit number"))
payload=atm:taboption("advanced",ListValue,"payload",translate("Forwarding mode"))
payload:value("bridged",translate("bridged"))
payload:value("routed",translate("routed"))
m.pageaction=true
end
local e=require"luci.model.network"
if e:has_ipv6()then
local e=m:section(NamedSection,"globals","globals",translate("Global network options"))
local e=e:option(Value,"ula_prefix",translate("IPv6 ULA-Prefix"))
e.datatype="ip6addr"
e.rmempty=true
m.pageaction=true
end
return m
