m=Map("network",translate("Switch"),translate("The network ports on this device can be combined to several <abbr title=\"Virtual Local Area Network\">VLAN</abbr>s in which computers can communicate directly with each other. <abbr title=\"Virtual Local Area Network\">VLAN</abbr>s are often used to separate different network segments. Often there is by default one Uplink port for a connection to the next greater network like the internet and other ports for a local network."))
local e=require"nixio.fs"
local g=require"luci.util"
local e=require"luci.model.network"
local u={}
e.init(m.uci)
local h=e:get_switch_topologies()or{}
local b=function(n,i)
local t={}
m.uci:foreach("network","interface",function(a)
local s=m.uci:get("network",a[".name"],"ifname")
local e={}
local o
local o=false
for t in luci.util.imatch(s)do
if t==n then
e[#e+1]=i
o=true
else
e[#e+1]=t
end
end
if o then
m.uci:set("network",a[".name"],"ifname",table.concat(e," "))
t[#t+1]=translatef("Interface %q device auto-migrated from %q to %q.",
a[".name"],n,i)
end
end)
if#t>0 then
m.message=(m.message and m.message.."\n"or"")..table.concat(t,"\n")
end
end
local p
m.uci:foreach("network","switch",
function(o)
local w=o['.name']
local t=o.name or w
local c=nil
local f=nil
local a=nil
local l=nil
local v=nil
local r=0
local e=16
local d=16
local i
local y=false
local n=h[t]
if not n then
m.message=translatef("Switch %q has an unknown topology - the VLAN settings might not be accurate.",t)
n={
ports={
{num=0,label="Port 1"},
{num=1,label="Port 2"},
{num=2,label="Port 3"},
{num=3,label="Port 4"},
{num=4,label="Port 5"},
{num=5,label="CPU (eth0)",tagged=false}
}
}
end
local h=io.popen("swconfig dev %s help 2>/dev/null"%g.shellquote(t))
if h then
local o=false
local t=false
while true do
local e=h:read("*l")
if not e then break end
if e:match("^%s+%-%-vlan")then
t=true
elseif e:match("^%s+%-%-port")then
t=false
o=true
elseif e:match("cpu @")then
i=e:match("^switch%d: %w+%((.-)%)")
d=tonumber(e:match("vlans: (%d+)"))or 16
r=1
elseif e:match(": pvid")or e:match(": tag")or e:match(": vid")then
if t then a=e:match(": (%w+)")end
elseif e:match(": enable_vlan4k")then
y=true
elseif e:match(": enable_vlan")then
c="enable_vlan"
elseif e:match(": enable_learning")then
f="enable_learning"
elseif e:match(": enable_mirror_rx")then
v="enable_mirror_rx"
elseif e:match(": max_length")then
l="max_length"
end
end
h:close()
end
s=m:section(NamedSection,o['.name'],"switch",
i and translatef("Switch %q (%s)",t,i)
or translatef("Switch %q",t))
s.addremove=false
if c then
s:option(Flag,c,translate("Enable VLAN functionality"))
end
if f then
o=s:option(Flag,f,translate("Enable learning and aging"))
o.default=o.enabled
end
if l then
o=s:option(Flag,l,translate("Enable Jumbo Frame passthrough"))
o.enabled="3"
o.rmempty=true
end
if v then
s:option(Flag,"enable_mirror_rx",translate("Enable mirroring of incoming packets"))
s:option(Flag,"enable_mirror_tx",translate("Enable mirroring of outgoing packets"))
local t=s:option(ListValue,"mirror_source_port",translate("Mirror source port"))
local a=s:option(ListValue,"mirror_monitor_port",translate("Mirror monitor port"))
t:depends("enable_mirror_tx","1")
t:depends("enable_mirror_rx","1")
a:depends("enable_mirror_tx","1")
a:depends("enable_mirror_rx","1")
local e,e
for o,e in ipairs(n.ports)do
t:value(e.num,e.label)
a:value(e.num,e.label)
end
end
s=m:section(TypedSection,"switch_vlan",
i and translatef("VLANs on %q (%s)",t,i)
or translatef("VLANs on %q",t))
s.template="cbi/tblsection"
s.addremove=true
s.anonymous=true
s.filter=function(a,e)
local e=m:get(e,"device")
return(e and e==t)
end
s.cfgsections=function(e)
local t=TypedSection.cfgsections(e)
local e={}
local o
for a,t in luci.util.spairs(
t,
function(e,o)
return(tonumber(m:get(t[e],a or"vlan"))or 9999)
<(tonumber(m:get(t[o],a or"vlan"))or 9999)
end
)do
e[#e+1]=t
end
return e
end
s.create=function(o,i,e)
if p then
return
elseif e==""then
local e=true
m.uci:foreach("network","switch_vlan",
function(a)
if a.device==t then
e=false
return false
end
end)
if not e then
return
end
elseif m:get(e,"device")~=t then
return
end
local e=TypedSection.create(o,i)
local i=0
local o=0
m.uci:foreach("network","switch_vlan",
function(e)
if e.device==t then
local t=tonumber(e.vlan)
local e=a and tonumber(e[a])
if t~=nil and t>i then i=t end
if e~=nil and e>o then o=e end
end
end)
m:set(e,"device",t)
m:set(e,"vlan",i+1)
if a then
m:set(e,a,o+1)
end
p=true
return e
end
local h={}
local o={}
local c=function(a,e)
local t
for e in(m:get(e,"ports")or""):gmatch("%w+")do
local t,e=e:match("^(%d+)([tu]*)")
if t==a.option then return(#e>0)and e or"u"end
end
return""
end
local l=function(e,t,a)
if t=="u"then
if not o[e.option]then
o[e.option]=true
else
return nil,
translatef("%s is untagged in multiple VLANs!",e.title)
end
end
return t
end
local o=s:option(Value,a or"vlan","VLAN ID")
local e=a and 4094 or(d-1)
o.rmempty=false
o.forcewrite=true
o.vlan_used={}
o.datatype="and(uinteger,range("..r..","..e.."))"
o.validate=function(n,i,e)
local e=tonumber(i)
local t=a and 4094 or(d-1)
if e~=nil and e>=r and e<=t then
if not n.vlan_used[e]then
n.vlan_used[e]=true
return i
else
return nil,
translatef("Invalid VLAN ID given! Only unique IDs are allowed")
end
else
return nil,
translatef("Invalid VLAN ID given! Only IDs between %d and %d are allowed.",r,t)
end
end
o.write=function(s,i,n)
local e
local a={}
for t,e in ipairs(h)do
local t=e:formvalue(i)
if t=="t"then
a[#a+1]=e.option..t
elseif t=="u"then
a[#a+1]=e.option
end
if e.info and e.info.device then
local a=e:cfgvalue(i)
local o=s:cfgvalue(i)
if a~=t or o~=n then
local a=(a=="u")and e.info.device
or"%s.%s"%{e.info.device,o}
local e=(t=="u")and e.info.device
or"%s.%s"%{e.info.device,n}
if a~=e then
b(a,e)
end
end
end
end
if y then
m:set(w,"enable_vlan4k","1")
end
m:set(i,"ports",table.concat(a," "))
return Value.write(s,i,n)
end
o.cfgvalue=function(t,e)
return m:get(e,a or"vlan")
or m:get(e,"vlan")
end
local e,e
for e,t in ipairs(n.ports)do
local e=s:option(ListValue,tostring(t.num),t.label)
e:value("",translate("off"))
if not t.tagged then
e:value("u",translate("untagged"))
end
e:value("t",translate("tagged"))
e.cfgvalue=c
e.validate=l
e.write=function()end
e.info=t
h[#h+1]=e
end
table.sort(h,function(t,e)return t.option<e.option end)
u[#u+1]=t
end
)
s=m:section(SimpleSection)
s.template="admin_network/switch_status"
s.switches=u
return m
