local e=require"nixio.fs"
local e=require"luci.util"
local i=require"luci.template"
local n=require"luci.model.network"
local h=pcall(require,"iwinfo")
function guess_wifi_hw(o)
local e=""
local t=o:name()
local i,a=t:match("^([a-z]+)(%d+)")
a=tonumber(a)
if h then
local t=o.iwinfo.hwmodelist
if t and next(t)then
if t.a then e=e.."a"end
if t.b then e=e.."b"end
if t.g then e=e.."g"end
if t.n then e=e.."n"end
if t.ac then e=e.."ac"end
end
local t=o.iwinfo.hardware_name
if t then
return"%s 802.11%s"%{t,e}
end
end
if i=="wl"then
local i=translatef("Broadcom 802.11%s Wireless Controller",e)
local e=0
local t=nixio.open("/proc/bus/pci/devices","r")
if t then
local o
for o in t:linesource()do
if o:match("wl$")then
if e==a then
local e=o:match("^%S+%s+%S%S%S%S([0-9a-f]+)")
i=translatef(
"Broadcom BCM%04x 802.11 Wireless Controller",
tonumber(e,16)
)
break
else
e=e+1
end
end
end
t:close()
end
return i
else
return translatef("Generic 802.11%s Wireless Controller",e)
end
end
local a=i.Template(nil,[[
	<div class="cbi-section-node">
		<div class="table">
			<!-- physical device -->
			<div class="tr cbi-rowstyle-2">
				<div class="td col-2 center middle">
					<span class="ifacebadge"><img src="<%=resource%>/icons/wifi_disabled.png" id="<%=dev:name()%>-iw-upstate" /> <%=dev:name()%></span>
				</div>
				<div class="td col-7 left middle">
					<big><strong><%=hw%></strong></big><br />
					<span id="<%=dev:name()%>-iw-devinfo"></span>
				</div>
				<div class="td middle cbi-section-actions">
					<div>
						<input type="button" class="cbi-button cbi-button-neutral" title="<%:Restart radio interface%>" value="<%:Restart%>" data-radio="<%=dev:name()%>" onclick="wifi_restart(event)" />
						<input type="button" class="cbi-button cbi-button-action important" title="<%:Find and join network%>" value="<%:Scan%>" onclick="cbi_submit(this, 'device', '<%=dev:name()%>', '<%=url('admin/network/wireless_join')%>')" />
						<input type="button" class="cbi-button cbi-button-add" title="<%:Provide new network%>" value="<%:Add%>" onclick="cbi_submit(this, 'device', '<%=dev:name()%>', '<%=url('admin/network/wireless_add')%>')" />
					</div>
				</div>
			</div>
			<!-- /physical device -->

			<!-- network list -->
			<% if #wnets > 0 then %>
				<% for i, net in ipairs(wnets) do local disabled = (dev:get("disabled") == "1" or net:get("disabled") == "1") %>
				<div class="tr cbi-rowstyle-<%=1 + ((i-1) % 2)%>">
					<div class="td col-2 center middle" id="<%=net:id()%>-iw-signal">
						<span class="ifacebadge" title="<%:Not associated%>"><img src="<%=resource%>/icons/signal-<%= disabled and "none" or "0" %>.png" /> 0%</span>
					</div>
					<div class="td col-7 left middle" id="<%=net:id()%>-iw-status" data-network="<%=net:id()%>" data-disabled="<%= disabled and "true" or "false" %>">
						<em><%= disabled and translate("Wireless is disabled") or translate("Collecting data...") %></em>
					</div>
					<div class="td middle cbi-section-actions">
						<div>
							<% if disabled then %>
								<input name="cbid.wireless.<%=net:name()%>.__disable__" type="hidden" value="1" />
								<input name="cbi.apply" type="submit" class="cbi-button cbi-button-neutral" title="<%:Enable this network%>" value="<%:Enable%>" onclick="this.previousElementSibling.value='0'" />
							<% else %>
								<input name="cbid.wireless.<%=net:name()%>.__disable__" type="hidden" value="0" />
								<input name="cbi.apply" type="submit" class="cbi-button cbi-button-neutral" title="<%:Disable this network%>" value="<%:Disable%>" onclick="this.previousElementSibling.value='1'" />
							<% end %>

							<input type="button" class="cbi-button cbi-button-action important" onclick="location.href='<%=net:adminlink()%>'" title="<%:Edit this network%>" value="<%:Edit%>" />

							<input name="cbid.wireless.<%=net:name()%>.__delete__" type="hidden" value="" />
							<input name="cbi.apply" type="submit" class="cbi-button cbi-button-negative" title="<%:Delete this network%>" value="<%:Remove%>" onclick="wifi_delete(event)" />
						</div>
					</div>
				</div>
				<% end %>
			<% else %>
				<div class="tr placeholder">
					<div class="td">
						<em><%:No network configured on this device%></em>
					</div>
				</div>
			<% end %>
			<!-- /network list -->
		</div>
	</div>
]])
m=Map("wireless",translate("Wireless Overview"))
m:chain("network")
m.pageaction=false
if not h then
s=m:section(NamedSection,"__warning__")
function s.render(e)
i.render_string([[
			<div class="alert-message warning">
				<h4><%:Package libiwinfo required!%></h4>
				<p><%_The <em>libiwinfo-lua</em> package is not installed. You must install this component for working wireless configuration!%></p>
			</div>
		]])
end
end
local e,e,e
for t,e in ipairs(n:get_wifidevs())do
s=m:section(TypedSection)
s.wnets=e:get_wifinets()
function s.render(t,o)
a:render({
hw=guess_wifi_hw(e),
dev=e,
wnets=t.wnets
})
end
function s.cfgsections(a)
local e,e,t=nil,nil,{}
for o,e in ipairs(a.wnets)do
t[#t+1]=e:name()
a.wnets[e:name()]=e
end
return t
end
o=s:option(Value,"__disable__")
function o.cfgvalue(e,t)
local e=e.section.wnets[t]
local t=e:get_device()
return((e and e:get("disabled")=="1")or
(t and t:get("disabled")=="1"))and"1"or"0"
end
function o.write(a,e,t)
local e=a.section.wnets[e]
local a=e:get_device()
if t~="1"then
e:set("disabled",nil)
a:set("disabled",nil)
else
e:set("disabled","1")
end
end
o.remove=o.write
o=s:option(Value,"__delete__")
function o.write(t,e,a)
local e=t.section.wnets[e]
local t=e:get_networks()
n:del_wifinet(e:id())
local e,e
for t,e in ipairs(t)do
if e:is_empty()then
n:del_network(e:name())
end
end
end
end
s=m:section(NamedSection,"__script__")
s.template="admin_network/wifi_overview_status"
s=m:section(NamedSection,"__assoclist__")
function s.render(e,e)
i.render_string([[
		<h2><%:Associated Stations%></h2>
		<%+admin_network/wifi_assoclist%>
	]])
end
return m
