local h=require"luci.dispatcher"
local e=require"luci.tools.firewall"
m=Map("firewall",
translate("Firewall - Traffic Rules"),
translate("Traffic rules define policies for packets traveling between \
		different zones, for example to reject traffic between certain hosts \
		or to open WAN ports on the router."))
s=m:section(TypedSection,"rule",translate("Traffic Rules"))
s.addremove=true
s.anonymous=true
s.sortable=true
s.template="cbi/tblsection"
s.extedit=h.build_url("admin/network/firewall/rules/%s")
s.defaults.target="ACCEPT"
s.template_addremove="firewall/cbi_addrule"
function s.create(e,t)
created=TypedSection.create(e,t)
end
function s.parse(e,...)
TypedSection.parse(e,...)
local r=m:formvalue("_newopen.name")
local t=m:formvalue("_newopen.proto")
local a=m:formvalue("_newopen.extport")
local n=m:formvalue("_newopen.submit")
local d=m:formvalue("_newfwd.name")
local s=m:formvalue("_newfwd.src")
local o=m:formvalue("_newfwd.dest")
local i=m:formvalue("_newfwd.submit")
if n then
created=TypedSection.create(e,section)
e.map:set(created,"target","ACCEPT")
e.map:set(created,"src","wan")
e.map:set(created,"proto",(t~="other")and t or"all")
e.map:set(created,"dest_port",a)
e.map:set(created,"name",r)
if t~="other"and a and#a>0 then
created=nil
end
elseif i then
created=TypedSection.create(e,section)
e.map:set(created,"target","ACCEPT")
e.map:set(created,"src",s)
e.map:set(created,"dest",o)
e.map:set(created,"name",d)
end
if created then
m.uci:save("firewall")
luci.http.redirect(h.build_url(
"admin/network/firewall/rules",created
))
end
end
function s.sectiontitle(e,t)
return(e.map:get(t,"name")or translate("Unnamed rule"))
end
local function d(o,a)
local t=o.map:get(a,"family")
local e=e.fmt_proto(o.map:get(a,"proto"),
o.map:get(a,"icmp_type"))or translate("traffic")
if t and t:match("4")then
return"%s-%s"%{translate("IPv4"),e}
elseif t and t:match("6")then
return"%s-%s"%{translate("IPv6"),e}
else
return"%s %s"%{translate("Any"),e}
end
end
local function r(i,n)
local o=e.fmt_zone(i.map:get(n,"src"))
local t=e.fmt_port(i.map:get(n,"src_port"))
local a=e.fmt_mac(i.map:get(n,"src_mac"))
if o and#o>0 then
local e=e.fmt_ip(i.map:get(n,"src_ip"),translate("any host"))
if t and a then
return translatef("From %s in %s with source %s and %s",e,o,t,a)
elseif t or a then
return translatef("From %s in %s with source %s",e,o,t or a)
else
return translatef("From %s in %s",e,o)
end
else
local e=e.fmt_ip(i.map:get(n,"src_ip"),translate("any router IP"))
if t and a then
return translatef("From %s on <var>this device</var> with source %s and %s",e,t,a)
elseif t or a then
return translatef("From %s on <var>this device</var> with source %s",e,t or a)
else
return translatef("From %s on <var>this device</var>",e)
end
end
end
local function n(a,t)
local i=e.fmt_zone(a.map:get(t,"dest"))
local o=e.fmt_port(a.map:get(t,"dest_port"))
if i then
local e=e.fmt_ip(a.map:get(t,"dest_ip"),translate("any host"))
if o then
return translatef("To %s, %s in %s",e,o,i)
else
return translatef("To %s in %s",e,i)
end
else
local e=e.fmt_ip(a.map:get(t,"dest_ip"),
translate("any router IP"))
if o then
return translatef("To %s at %s on <var>this device</var>",e,o)
else
return translatef("To %s on <var>this device</var>",e)
end
end
end
local function l(t,a)
local o=e.fmt_zone(t.map:get(a,"dest"),translate("any zone"))
local i=e.fmt_ip(t.map:get(a,"dest_ip"),translate("any host"))
local e=e.fmt_port(t.map:get(a,"dest_port"))or
e.fmt_port(t.map:get(a,"src_dport"))
if e then
return translatef("To %s, %s in %s",i,e,o)
else
return translatef("To %s in %s",i,o)
end
end
match=s:option(DummyValue,"match",translate("Match"))
match.rawhtml=true
function match.cfgvalue(t,e)
return"<small>%s<br />%s<br />%s</small>"%{
d(t,e),
r(t,e),
n(t,e)
}
end
target=s:option(DummyValue,"target",translate("Action"))
target.rawhtml=true
function target.cfgvalue(t,a)
local o=e.fmt_target(t.map:get(a,"target"),t.map:get(a,"src"),t.map:get(a,"dest"))
local t=e.fmt_limit(t.map:get(a,"limit"),
t.map:get(a,"limit_burst"))
if t then
return translatef("<var>%s</var> and limit to %s",o,t)
else
return"<var>%s</var>"%o
end
end
e.opt_enabled(s,Flag,translate("Enable"))
s=m:section(TypedSection,"redirect",
translate("Source NAT"),
translate("Source NAT is a specific form of masquerading which allows \
		fine grained control over the source IP used for outgoing traffic, \
		for example to map multiple WAN addresses to internal subnets."))
s.template="cbi/tblsection"
s.addremove=true
s.anonymous=true
s.sortable=true
s.extedit=h.build_url("admin/network/firewall/rules/%s")
s.template_addremove="firewall/cbi_addsnat"
function s.create(e,t)
created=TypedSection.create(e,t)
end
function s.parse(e,...)
TypedSection.parse(e,...)
local s=m:formvalue("_newsnat.name")
local n=m:formvalue("_newsnat.src")
local i=m:formvalue("_newsnat.dest")
local t=m:formvalue("_newsnat.dip")
local a=m:formvalue("_newsnat.dport")
local o=m:formvalue("_newsnat.submit")
if o and t and#t>0 then
created=TypedSection.create(e,section)
e.map:set(created,"target","SNAT")
e.map:set(created,"src",n)
e.map:set(created,"dest",i)
e.map:set(created,"proto","all")
e.map:set(created,"src_dip",t)
e.map:set(created,"src_dport",a)
e.map:set(created,"name",s)
end
if created then
m.uci:save("firewall")
luci.http.redirect(h.build_url(
"admin/network/firewall/rules",created
))
end
end
function s.filter(t,e)
return(t.map:get(e,"target")=="SNAT")
end
function s.sectiontitle(t,e)
return(t.map:get(e,"name")or translate("Unnamed SNAT"))
end
match=s:option(DummyValue,"match",translate("Match"))
match.rawhtml=true
function match.cfgvalue(t,e)
return"<small>%s<br />%s<br />%s</small>"%{
d(t,e),
r(t,e),
l(t,e)
}
end
snat=s:option(DummyValue,"via",translate("Action"))
snat.rawhtml=true
function snat.cfgvalue(o,a)
local t=e.fmt_ip(o.map:get(a,"src_dip"))
local a=e.fmt_port(o.map:get(a,"src_dport"))
if t and a then
return translatef("Rewrite to source %s, %s",t,a)
else
return translatef("Rewrite to source %s",t or a)
end
end
e.opt_enabled(s,Flag,translate("Enable"))
return m
