local c=require"luci.model.network"
local l=require"luci.model.firewall"
local p=require"luci.dispatcher"
local w=require"luci.util"
local o,y,e,e
local t,h,n,d,s,r,f,m
local u,i,a
o=Map("firewall",translate("Firewall - Zone Settings"))
o.redirect=luci.dispatcher.build_url("admin/network/firewall/zones")
l.init(o.uci)
c.init(o.uci)
local e=l:get_zone(arg[1])
if not e then
luci.http.redirect(p.build_url("admin/network/firewall/zones"))
return
else
o.title="%s - %s"%{
translate("Firewall - Zone Settings"),
translatef("Zone %q",e:name()or"?")
}
end
t=o:section(NamedSection,e.sid,"zone",
translatef("Zone %q",e:name()),
translatef("This section defines common properties of %q. \
		The <em>input</em> and <em>output</em> options set the default \
		policies for traffic entering and leaving this zone while the \
		<em>forward</em> option describes the policy for forwarded traffic \
		between different networks within the zone. \
		<em>Covered networks</em> specifies which available networks are \
		members of this zone.",e:name()))
t.anonymous=true
t.addremove=false
o.on_commit=function(e)
local e=l:get_zone(arg[1])
if e then
t.section=e.sid
u.section=e.sid
end
end
t:tab("general",translate("General Settings"))
t:tab("advanced",translate("Advanced Settings"))
h=t:taboption("general",Value,"name",translate("Name"))
h.optional=false
h.forcewrite=true
h.datatype="and(uciname,maxlength(11))"
function h.write(o,o,t)
if e:name()~=t then
l:rename_zone(e:name(),t)
i.exclude=t
a.exclude=t
end
end
y={
t:taboption("general",ListValue,"input",translate("Input")),
t:taboption("general",ListValue,"output",translate("Output")),
t:taboption("general",ListValue,"forward",translate("Forward"))
}
for a,e in ipairs(y)do
e:value("REJECT",translate("reject"))
e:value("DROP",translate("drop"))
e:value("ACCEPT",translate("accept"))
end
t:taboption("general",Flag,"masq",translate("Masquerading"))
t:taboption("general",Flag,"mtu_fix",translate("MSS clamping"))
n=t:taboption("general",Value,"network",translate("Covered networks"))
n.template="cbi/network_netlist"
n.widget="checkbox"
n.cast="string"
function n.formvalue(t,e)
return Value.formvalue(t,e)or"-"
end
function n.cfgvalue(t,e)
return Value.cfgvalue(t,e)or h:cfgvalue(e)
end
function n.write(a,a,t)
e:clear_networks()
local a
for t in w.imatch(t)do
local t=c:get_network(t)or c:add_network(t,{proto="none"})
if t then
e:add_network(t:name())
end
end
end
d=t:taboption("advanced",ListValue,"family",
translate("Restrict to address family"))
d.rmempty=true
d:value("",translate("IPv4 and IPv6"))
d:value("ipv4",translate("IPv4 only"))
d:value("ipv6",translate("IPv6 only"))
s=t:taboption("advanced",DynamicList,"masq_src",
translate("Restrict Masquerading to given source subnets"))
s.optional=true
s.datatype="list(neg(or(uciname,hostname,ipmask4)))"
s.placeholder="0.0.0.0/0"
s:depends("family","")
s:depends("family","ipv4")
r=t:taboption("advanced",DynamicList,"masq_dest",
translate("Restrict Masquerading to given destination subnets"))
r.optional=true
r.datatype="list(neg(or(uciname,hostname,ipmask4)))"
r.placeholder="0.0.0.0/0"
r:depends("family","")
r:depends("family","ipv4")
t:taboption("advanced",Flag,"conntrack",
translate("Force connection tracking"))
f=t:taboption("advanced",Flag,"log",
translate("Enable logging on this zone"))
f.rmempty=true
f.enabled="1"
m=t:taboption("advanced",Value,"log_limit",
translate("Limit log messages"))
m.placeholder="10/minute"
m:depends("log","1")
u=o:section(NamedSection,e.sid,"fwd_out",
translate("Inter-Zone Forwarding"),
translatef("The options below control the forwarding policies between \
		this zone (%s) and other zones. <em>Destination zones</em> cover \
		forwarded traffic <strong>originating from %q</strong>. \
		<em>Source zones</em> match forwarded traffic from other zones \
		<strong>targeted at %q</strong>. The forwarding rule is \
		<em>unidirectional</em>, e.g. a forward from lan to wan does \
		<em>not</em> imply a permission to forward from wan to lan as well.",
e:name(),e:name(),e:name()
))
i=u:option(Value,"out",
translate("Allow forward to <em>destination zones</em>:"))
i.nocreate=true
i.widget="checkbox"
i.exclude=e:name()
i.template="cbi/firewall_zonelist"
a=u:option(Value,"in",
translate("Allow forward from <em>source zones</em>:"))
a.nocreate=true
a.widget="checkbox"
a.exclude=e:name()
a.template="cbi/firewall_zonelist"
function i.cfgvalue(t,t)
local t={}
local a
for a,e in ipairs(e:get_forwardings_by("src"))do
t[#t+1]=e:dest()
end
return table.concat(t," ")
end
function a.cfgvalue(t,t)
local t={}
local a
for a,e in ipairs(e:get_forwardings_by("dest"))do
t[#t+1]=e:src()
end
return t
end
function i.formvalue(t,e)
return Value.formvalue(t,e)or"-"
end
function a.formvalue(t,e)
return Value.formvalue(t,e)or"-"
end
function i.write(a,a,t)
e:del_forwardings_by("src")
local a
for t in w.imatch(t)do
e:add_forwarding_to(t)
end
end
function a.write(a,a,t)
e:del_forwardings_by("dest")
local a
for t in w.imatch(t)do
e:add_forwarding_from(t)
end
end
return o
