local n=require"luci.dispatcher"
local o=require"luci.model.firewall"
local s=require"nixio.fs"
local a,e,t,i,h,h
a=Map("firewall",
translate("Firewall - Zone Settings"),
translate("The firewall creates zones over your network interfaces to control network traffic flow."))
o.init(a.uci)
e=a:section(TypedSection,"defaults",translate("General Settings"))
e.anonymous=true
e.addremove=false
e:option(Flag,"syn_flood",translate("Enable SYN-flood protection"))
t=e:option(Flag,"drop_invalid",translate("Drop invalid packets"))
i={
e:option(ListValue,"input",translate("Input")),
e:option(ListValue,"output",translate("Output")),
e:option(ListValue,"forward",translate("Forward"))
}
for t,e in ipairs(i)do
e:value("REJECT",translate("reject"))
e:value("DROP",translate("drop"))
e:value("ACCEPT",translate("accept"))
end
local s=s.access("/sys/module/xt_FLOWOFFLOAD/refcnt")
if s then
e:option(DummyValue,"offload_advice",
translate("Routing/NAT Offloading"),
translate("Experimental feature. Not fully compatible with QoS/SQM."))
t=e:option(Flag,"flow_offloading",
translate("Software flow offloading"),
translate("Software based offloading for routing/NAT"))
t.optional=true
t=e:option(Flag,"flow_offloading_hw",
translate("Hardware flow offloading"),
translate("Requires hardware NAT support. Implemented at least for mt7621"))
t.optional=true
t:depends("flow_offloading",1)
end
e=a:section(TypedSection,"zone",translate("Zones"))
e.template="cbi/tblsection"
e.anonymous=true
e.addremove=true
e.extedit=n.build_url("admin","network","firewall","zones","%s")
function e.sectiontitle(t,e)
local e=o:get_zone(e)
return e:name()
end
function e.create(e)
local e=o:new_zone()
if e then
luci.http.redirect(
n.build_url("admin","network","firewall","zones",e.sid)
)
end
end
function e.remove(a,e)
return o:del_zone(e)
end
t=e:option(DummyValue,"_info",translate("Zone ⇒ Forwardings"))
t.template="cbi/firewall_zoneforwards"
t.cfgvalue=function(e,t)
return e.map:get(t,"name")
end
i={
e:option(ListValue,"input",translate("Input")),
e:option(ListValue,"output",translate("Output")),
e:option(ListValue,"forward",translate("Forward"))
}
for a,t in ipairs(i)do
t:value("REJECT",translate("reject"))
t:value("DROP",translate("drop"))
t:value("ACCEPT",translate("accept"))
end
e:option(Flag,"masq",translate("Masquerading"))
e:option(Flag,"mtu_fix",translate("MSS clamping"))
return a
